???File Path
==========
***...\Models\travel\PackageModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@  PackageDetails  @@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlPackageDetails {

	public long binPackageDetailsId { get; set; } = 0;
	[Required()]
	[Display(Name = "Package Master")]
	public long binPackageMasterId { get; set; } = 0;
	public short sinType { get; set; } = 0;
	
	public long? binCommissionAcId { get; set; } = null;
	public long? binSupFeeAcId { get; set; } = null;
	public long? binSupplierAcId { get; set; } = null;
	public long? binServiceFeeAcId { get; set; } = null;
	public long? binDiscountAcId { get; set; } = null;
	
	public string strParticulars { get; set; } = "";
	
	public double dblFare { get; set; } = 0.0;
	public double dblTax { get; set; } = 0.0;
	public double dblCommission { get; set; } = 0.0;
	public double dblSupFee { get; set; } = 0.0;
	public double dblCost { get; set; } = 0.0;
	public double dblServiceFee { get; set; } = 0.0;
	public double dblDiscount { get; set; } = 0.0;
	public double dblPrice { get; set; } = 0.0;
	
}

public class MdlReqPackageDetails : MdlRequest {

	public MdlPackageDetails mdlPackageDetails { get; set; } = new MdlPackageDetails();
}

public class MdlResPackageDetails : MdlResponse {

	public MdlPackageDetails mdlPackageDetails { get; set; } = new MdlPackageDetails();
}

public class MdlResPackageDetailsList : MdlResponse {

	public List<MdlPackageDetails> lstMdlPackageDetails { get; set; } = new List<MdlPackageDetails>();
}

public class MdlResPackageDetailsInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlPackageMasterBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlCommissionAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlSupFeeAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlSupplierAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlServiceFeeAcBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlDiscountAcBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlPackageDetails> lstMdlPackageDetails { get; set; } = new List<MdlPackageDetails>();
}

