???File Path
==========
***...\ClientApp\srcpp\modelsase\package.model.ts


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@  PackageDetails  @@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
export class MdlPackageDetails {

	binPackageDetailsId: number = 0;
	binPackageMasterId: number = 0;
	strPackageMaster: string = "";
	sinType: number = 0;
	
	binCommissionAcId: number | null = null;
	strCommissionAcCode: string = "";
	strCommissionAcName: string = "";
	binSupFeeAcId: number | null = null;
	strSupFeeAcCode: string = "";
	strSupFeeAcName: string = "";
	binSupplierAcId: number | null = null;
	strSupplierAcCode: string = "";
	strSupplierAcName: string = "";
	binServiceFeeAcId: number | null = null;
	strServiceFeeAcCode: string = "";
	strServiceFeeAcName: string = "";
	binDiscountAcId: number | null = null;
	strDiscountAcCode: string = "";
	strDiscountAcName: string = "";
	
	strParticulars: string = "";
	
	dblFare: number = 0.0;
	dblTax: number = 0.0;
	dblCommission: number = 0.0;
	dblSupFee: number = 0.0;
	dblCost: number = 0.0;
	dblServiceFee: number = 0.0;
	dblDiscount: number = 0.0;
	dblPrice: number = 0.0;
	
}

export class MdlReqPackageDetails extends MdlRequest {

	mdlPackageDetails:MdlPackageDetails = new MdlPackageDetails();
}

export class MdlResPackageDetails extends MdlResponse {

	mdlPackageDetails:MdlPackageDetails = new MdlPackageDetails();
}

export class MdlResPackageDetailsList extends MdlResponse {

	lstMdlPackageDetails: MdlPackageDetails[] = [];
}

export class MdlResPackageDetailsInit extends MdlResponse {
	lstMdlPackageMasterBaseIntId: MdlBaseIntId[] = [];
	lstMdlCommissionAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlSupFeeAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlSupplierAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlServiceFeeAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlDiscountAcBaseIntId: MdlBaseIntId[] = [];


	lstMdlPackageDetails: MdlPackageDetails[] = [];
}

