???File Path
==========
***...\ClientApp\srcpp\modelsase\package.model.ts


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@  PackageMaster  @@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
export class MdlPackageMaster extends MdlUserAction {

	binPackageMasterId: number = 0;
	
	binPackageCategoryId: number = 0;
	strPackageCategory: string = "";
	binIncomeAcId: number | null = null;
	strIncomeAcCode: string = "";
	strIncomeAcName: string = "";
	binControlAcId: number | null = null;
	strControlAcCode: string = "";
	strControlAcName: string = "";
	
	strPackageCode: string = "";
	strPackageName: string = "";
	sinDefault: number = 0;
	sinOwnPackage: number = 0;
	strErpCode: string = "";
	
	datIssueFrom: any = null;
	datIssueTo: any = null;
	datServiceFrom: any = null;
	datServiceTo: any = null;
	
	sinAllowStock: number = 1;
	sinNoOfDays: number = 1;
	sinNoOfPax: number = 1;
	sinAdult: number = 1;
	sinChild: number = 0;
	sinInfant: number = 0;
	
	arlFkBranchIds: number[] = [];
	arlFkServiceIds: number[] = [];
	
	strRemarks: string = "";
	
	sinAdditionalItemInInvoicePrint: number = 1;
	sinAdditionalItemDetailsInFileOpenPrint: number = 1;
	sinPrintInformationInInvoicePrint: number = 1;
	sinPrintInformationDetailsInFileOpenPrint: number = 1;
	
	binSupplierAcId: number | null = null;
	strSupplierAcCode: string = "";
	strSupplierAcName: string = "";
	binSupplierSideControlAcId: number | null = null;
	strSupplierSideControlAcCode: string = "";
	strSupplierSideControlAcName: string = "";
	binCommissionAcId: number | null = null;
	strCommissionAcCode: string = "";
	strCommissionAcName: string = "";
	binServiceFeeAcId: number | null = null;
	strServiceFeeAcCode: string = "";
	strServiceFeeAcName: string = "";
	binManagementFeeAcId: number | null = null;
	strManagementFeeAcCode: string = "";
	strManagementFeeAcName: string = "";
	binPaybackAcId: number | null = null;
	strPaybackAcCode: string = "";
	strPaybackAcName: string = "";
	binDiscountAcId: number | null = null;
	strDiscountAcCode: string = "";
	strDiscountAcName: string = "";
	
	strBaseCurrency: string = "";
	dblBaseCurFare: number = 0.0;
	dblBaseCurTax: number = 0.0;
	dblBaseCurCommPercentage: number = 0.0;
	dblBaseCurCommissionAmount: number = 0.0;
	dblBaseCurSupplierFeePerc: number = 0.0;
	dblBaseCurSupplierFee: number = 0.0;
	dblBaseCurSupplierAmount: number = 0.0;
	dblBaseCurServiceFeePerc: number = 0.0;
	dblBaseCurServiceFee: number = 0.0;
	dblBaseCurManagementFeePerc: number = 0.0;
	dblBaseCurManagementFee: number = 0.0;
	dblBaseCurDiscountPerc: number = 0.0;
	dblBaseCurDiscount: number = 0.0;
	dblBaseCurCost: number = 0.0;
	dblBaseCurPrice: number = 0.0;
	
	strSupCurrency: string = "";
	dblSupCurRoe: number = 1.00;
	dblSupCurFare: number = 0.0;
	dblSupCurTax: number = 0.0;
	dblSupCurCommPercentage: number = 0.0;
	dblSupCurCommissionAmount: number = 0.0;
	dblSupCurSupplierFeePerc: number = 0.0;
	dblSupCurSupplierFee: number = 0.0;
	dblSupCurSupplierAmount: number = 0.0;
	dblSupCurServiceFeePerc: number = 0.0;
	dblSupCurServiceFee: number = 0.0;
	dblSupCurManagementFeePerc: number = 0.0;
	dblSupCurManagementFee: number = 0.0;
	dblSupCurDiscountPerc: number = 0.0;
	dblSupCurDiscount: number = 0.0;
	dblSupCurCost: number = 0.0;
	dblSupCurPrice: number = 0.0;
	
	jsnBatchDetails: string = "[]";
	
	sinRecordStatus: number = 1;
	sinOrder: number = 1;
	
}

export class MdlReqPackageMaster extends MdlRequest {

	mdlPackageMaster:MdlPackageMaster = new MdlPackageMaster();
}

export class MdlResPackageMaster extends MdlResponse {

	mdlPackageMaster:MdlPackageMaster = new MdlPackageMaster();
}

export class MdlResPackageMasterList extends MdlResponse {

	lstMdlPackageMaster: MdlPackageMaster[] = [];
}

export class MdlResPackageMasterInit extends MdlResponse {
	lstMdlPackageCategoryBaseIntId: MdlBaseIntId[] = [];
	lstMdlIncomeAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlControlAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlSupplierAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlSupplierSideControlAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlCommissionAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlServiceFeeAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlManagementFeeAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlPaybackAcBaseIntId: MdlBaseIntId[] = [];
	lstMdlDiscountAcBaseIntId: MdlBaseIntId[] = [];


	lstMdlPackageMaster: MdlPackageMaster[] = [];
}

