???File Path
==========
***...\Src\Accounts\PackageMaster.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Accounts;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllPackageMasterBaseData()
            {
                List<MdlBaseIntId> lstMdlPackageMasterBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_package_master()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_package_master_id"]) ? (long)Convert.ToUInt64(objRecord["pk_package_master_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord["vhr_package_code"]) ? Convert.ToString(objRecord["vhr_package_code"]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord["vhr_package_name"]) ? Convert.ToString(objRecord["vhr_package_name"]) : mdlBaseIntId.strName;
        
                        lstMdlPackageMasterBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlPackageMasterBaseIntId;
            }
        


            public List<MdlPackageMaster> FnGetAllPackageMasterWithActionUser()
            {
                List<MdlPackageMaster> lstMdlPackageMaster = new List<MdlPackageMaster>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_package_master_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlPackageMaster mdlPackageMaster = new MdlPackageMaster();

                        
				mdlPackageMaster.binPackageMasterId = (DBNull.Value != objRecord["pk_package_master_id"]) ? (long)Convert.ToInt64(objRecord["pk_package_master_id"]) : mdlPackageMaster.binPackageMasterId;

				mdlPackageMaster.binPackageCategoryId = (DBNull.Value != objRecord["fk_package_category_id"]) ? (long)Convert.ToInt64(objRecord["fk_package_category_id"]) : mdlPackageMaster.binPackageCategoryId;
				mdlPackageMaster.binIncomeAcId = (DBNull.Value != objRecord["fk_income_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_income_ac_id"]) : mdlPackageMaster.binIncomeAcId;
				mdlPackageMaster.binControlAcId = (DBNull.Value != objRecord["fk_control_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_control_ac_id"]) : mdlPackageMaster.binControlAcId;

				mdlPackageMaster.strPackageCode = (DBNull.Value != objRecord["vhr_package_code"]) ? Convert.ToString(objRecord["vhr_package_code"]) : mdlPackageMaster.strPackageCode;
				mdlPackageMaster.strPackageName = (DBNull.Value != objRecord["vhr_package_name"]) ? Convert.ToString(objRecord["vhr_package_name"]) : mdlPackageMaster.strPackageName;
				mdlPackageMaster.sinDefault = (DBNull.Value != objRecord["sin_default"]) ? (short)Convert.ToInt16(objRecord["sin_default"]) : mdlPackageMaster.sinDefault;
				mdlPackageMaster.sinOwnPackage = (DBNull.Value != objRecord["sin_own_package"]) ? (short)Convert.ToInt16(objRecord["sin_own_package"]) : mdlPackageMaster.sinOwnPackage;
				mdlPackageMaster.strErpCode = (DBNull.Value != objRecord["vhr_erp_code"]) ? Convert.ToString(objRecord["vhr_erp_code"]) : mdlPackageMaster.strErpCode;

				mdlPackageMaster.datIssueFrom = (DBNull.Value != objRecord["dat_issue_from"]) ? (DateTime)Convert.ToDateTime(objRecord["dat_issue_from"]) : mdlPackageMaster.datIssueFrom;
				mdlPackageMaster.datIssueTo = (DBNull.Value != objRecord["dat_issue_to"]) ? (DateTime)Convert.ToDateTime(objRecord["dat_issue_to"]) : mdlPackageMaster.datIssueTo;
				mdlPackageMaster.datServiceFrom = (DBNull.Value != objRecord["dat_service_from"]) ? (DateTime)Convert.ToDateTime(objRecord["dat_service_from"]) : mdlPackageMaster.datServiceFrom;
				mdlPackageMaster.datServiceTo = (DBNull.Value != objRecord["dat_service_to"]) ? (DateTime)Convert.ToDateTime(objRecord["dat_service_to"]) : mdlPackageMaster.datServiceTo;

				mdlPackageMaster.sinAllowStock = (DBNull.Value != objRecord["sin_allow_stock"]) ? (short)Convert.ToInt16(objRecord["sin_allow_stock"]) : mdlPackageMaster.sinAllowStock;
				mdlPackageMaster.sinNoOfDays = (DBNull.Value != objRecord["sin_no_of_days"]) ? (short)Convert.ToInt16(objRecord["sin_no_of_days"]) : mdlPackageMaster.sinNoOfDays;
				mdlPackageMaster.sinNoOfPax = (DBNull.Value != objRecord["sin_no_of_pax"]) ? (short)Convert.ToInt16(objRecord["sin_no_of_pax"]) : mdlPackageMaster.sinNoOfPax;
				mdlPackageMaster.sinAdult = (DBNull.Value != objRecord["sin_adult"]) ? (short)Convert.ToInt16(objRecord["sin_adult"]) : mdlPackageMaster.sinAdult;
				mdlPackageMaster.sinChild = (DBNull.Value != objRecord["sin_child"]) ? (short)Convert.ToInt16(objRecord["sin_child"]) : mdlPackageMaster.sinChild;
				mdlPackageMaster.sinInfant = (DBNull.Value != objRecord["sin_infant"]) ? (short)Convert.ToInt16(objRecord["sin_infant"]) : mdlPackageMaster.sinInfant;

				mdlPackageMaster.arlFkBranchIds = (DBNull.Value != objRecord["arb_fk_branch_ids"]) ? (long[])objRecord["arb_fk_branch_ids"] : mdlPackageMaster.arlFkBranchIds;
				mdlPackageMaster.arlFkServiceIds = (DBNull.Value != objRecord["arb_fk_service_ids"]) ? (long[])objRecord["arb_fk_service_ids"] : mdlPackageMaster.arlFkServiceIds;

				mdlPackageMaster.strRemarks = (DBNull.Value != objRecord["txt_remarks"]) ? Convert.ToString(objRecord["txt_remarks"]) : mdlPackageMaster.strRemarks;

				mdlPackageMaster.sinAdditionalItemInInvoicePrint = (DBNull.Value != objRecord["sin_additional_item_in_invoice_print"]) ? (short)Convert.ToInt16(objRecord["sin_additional_item_in_invoice_print"]) : mdlPackageMaster.sinAdditionalItemInInvoicePrint;
				mdlPackageMaster.sinAdditionalItemDetailsInFileOpenPrint = (DBNull.Value != objRecord["sin_additional_item_details_in_file_open_print"]) ? (short)Convert.ToInt16(objRecord["sin_additional_item_details_in_file_open_print"]) : mdlPackageMaster.sinAdditionalItemDetailsInFileOpenPrint;
				mdlPackageMaster.sinPrintInformationInInvoicePrint = (DBNull.Value != objRecord["sin_print_information_in_invoice_print"]) ? (short)Convert.ToInt16(objRecord["sin_print_information_in_invoice_print"]) : mdlPackageMaster.sinPrintInformationInInvoicePrint;
				mdlPackageMaster.sinPrintInformationDetailsInFileOpenPrint = (DBNull.Value != objRecord["sin_print_information_details_in_file_open_print"]) ? (short)Convert.ToInt16(objRecord["sin_print_information_details_in_file_open_print"]) : mdlPackageMaster.sinPrintInformationDetailsInFileOpenPrint;

				mdlPackageMaster.binSupplierAcId = (DBNull.Value != objRecord["fk_supplier_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_supplier_ac_id"]) : mdlPackageMaster.binSupplierAcId;
				mdlPackageMaster.binSupplierSideControlAcId = (DBNull.Value != objRecord["fk_supplier_side_control_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_supplier_side_control_ac_id"]) : mdlPackageMaster.binSupplierSideControlAcId;
				mdlPackageMaster.binCommissionAcId = (DBNull.Value != objRecord["fk_commission_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_commission_ac_id"]) : mdlPackageMaster.binCommissionAcId;
				mdlPackageMaster.binServiceFeeAcId = (DBNull.Value != objRecord["fk_service_fee_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_service_fee_ac_id"]) : mdlPackageMaster.binServiceFeeAcId;
				mdlPackageMaster.binManagementFeeAcId = (DBNull.Value != objRecord["fk_management_fee_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_management_fee_ac_id"]) : mdlPackageMaster.binManagementFeeAcId;
				mdlPackageMaster.binPaybackAcId = (DBNull.Value != objRecord["fk_payback_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_payback_ac_id"]) : mdlPackageMaster.binPaybackAcId;
				mdlPackageMaster.binDiscountAcId = (DBNull.Value != objRecord["fk_discount_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_discount_ac_id"]) : mdlPackageMaster.binDiscountAcId;

				mdlPackageMaster.strBaseCurrency = (DBNull.Value != objRecord["vhr_base_currency"]) ? Convert.ToString(objRecord["vhr_base_currency"]) : mdlPackageMaster.strBaseCurrency;
				mdlPackageMaster.dblBaseCurFare = (DBNull.Value != objRecord["dbl_base_cur_fare"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_fare"]) : mdlPackageMaster.dblBaseCurFare;
				mdlPackageMaster.dblBaseCurTax = (DBNull.Value != objRecord["dbl_base_cur_tax"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_tax"]) : mdlPackageMaster.dblBaseCurTax;
				mdlPackageMaster.dblBaseCurCommPercentage = (DBNull.Value != objRecord["dbl_base_cur_comm_percentage"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_comm_percentage"]) : mdlPackageMaster.dblBaseCurCommPercentage;
				mdlPackageMaster.dblBaseCurCommissionAmount = (DBNull.Value != objRecord["dbl_base_cur_commission_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_commission_amount"]) : mdlPackageMaster.dblBaseCurCommissionAmount;
				mdlPackageMaster.dblBaseCurSupplierFeePerc = (DBNull.Value != objRecord["dbl_base_cur_supplier_fee_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_supplier_fee_perc"]) : mdlPackageMaster.dblBaseCurSupplierFeePerc;
				mdlPackageMaster.dblBaseCurSupplierFee = (DBNull.Value != objRecord["dbl_base_cur_supplier_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_supplier_fee"]) : mdlPackageMaster.dblBaseCurSupplierFee;
				mdlPackageMaster.dblBaseCurSupplierAmount = (DBNull.Value != objRecord["dbl_base_cur_supplier_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_supplier_amount"]) : mdlPackageMaster.dblBaseCurSupplierAmount;
				mdlPackageMaster.dblBaseCurServiceFeePerc = (DBNull.Value != objRecord["dbl_base_cur_service_fee_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_service_fee_perc"]) : mdlPackageMaster.dblBaseCurServiceFeePerc;
				mdlPackageMaster.dblBaseCurServiceFee = (DBNull.Value != objRecord["dbl_base_cur_service_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_service_fee"]) : mdlPackageMaster.dblBaseCurServiceFee;
				mdlPackageMaster.dblBaseCurManagementFeePerc = (DBNull.Value != objRecord["dbl_base_cur_management_fee_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_management_fee_perc"]) : mdlPackageMaster.dblBaseCurManagementFeePerc;
				mdlPackageMaster.dblBaseCurManagementFee = (DBNull.Value != objRecord["dbl_base_cur_management_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_management_fee"]) : mdlPackageMaster.dblBaseCurManagementFee;
				mdlPackageMaster.dblBaseCurDiscountPerc = (DBNull.Value != objRecord["dbl_base_cur_discount_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_discount_perc"]) : mdlPackageMaster.dblBaseCurDiscountPerc;
				mdlPackageMaster.dblBaseCurDiscount = (DBNull.Value != objRecord["dbl_base_cur_discount"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_discount"]) : mdlPackageMaster.dblBaseCurDiscount;
				mdlPackageMaster.dblBaseCurCost = (DBNull.Value != objRecord["dbl_base_cur_cost"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_cost"]) : mdlPackageMaster.dblBaseCurCost;
				mdlPackageMaster.dblBaseCurPrice = (DBNull.Value != objRecord["dbl_base_cur_price"]) ? (double)Convert.ToDouble(objRecord["dbl_base_cur_price"]) : mdlPackageMaster.dblBaseCurPrice;

				mdlPackageMaster.strSupCurrency = (DBNull.Value != objRecord["vhr_sup_currency"]) ? Convert.ToString(objRecord["vhr_sup_currency"]) : mdlPackageMaster.strSupCurrency;
				mdlPackageMaster.dblSupCurRoe = (DBNull.Value != objRecord["dbl_sup_cur_roe"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_roe"]) : mdlPackageMaster.dblSupCurRoe;
				mdlPackageMaster.dblSupCurFare = (DBNull.Value != objRecord["dbl_sup_cur_fare"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_fare"]) : mdlPackageMaster.dblSupCurFare;
				mdlPackageMaster.dblSupCurTax = (DBNull.Value != objRecord["dbl_sup_cur_tax"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_tax"]) : mdlPackageMaster.dblSupCurTax;
				mdlPackageMaster.dblSupCurCommPercentage = (DBNull.Value != objRecord["dbl_sup_cur_comm_percentage"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_comm_percentage"]) : mdlPackageMaster.dblSupCurCommPercentage;
				mdlPackageMaster.dblSupCurCommissionAmount = (DBNull.Value != objRecord["dbl_sup_cur_commission_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_commission_amount"]) : mdlPackageMaster.dblSupCurCommissionAmount;
				mdlPackageMaster.dblSupCurSupplierFeePerc = (DBNull.Value != objRecord["dbl_sup_cur_supplier_fee_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_supplier_fee_perc"]) : mdlPackageMaster.dblSupCurSupplierFeePerc;
				mdlPackageMaster.dblSupCurSupplierFee = (DBNull.Value != objRecord["dbl_sup_cur_supplier_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_supplier_fee"]) : mdlPackageMaster.dblSupCurSupplierFee;
				mdlPackageMaster.dblSupCurSupplierAmount = (DBNull.Value != objRecord["dbl_sup_cur_supplier_amount"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_supplier_amount"]) : mdlPackageMaster.dblSupCurSupplierAmount;
				mdlPackageMaster.dblSupCurServiceFeePerc = (DBNull.Value != objRecord["dbl_sup_cur_service_fee_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_service_fee_perc"]) : mdlPackageMaster.dblSupCurServiceFeePerc;
				mdlPackageMaster.dblSupCurServiceFee = (DBNull.Value != objRecord["dbl_sup_cur_service_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_service_fee"]) : mdlPackageMaster.dblSupCurServiceFee;
				mdlPackageMaster.dblSupCurManagementFeePerc = (DBNull.Value != objRecord["dbl_sup_cur_management_fee_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_management_fee_perc"]) : mdlPackageMaster.dblSupCurManagementFeePerc;
				mdlPackageMaster.dblSupCurManagementFee = (DBNull.Value != objRecord["dbl_sup_cur_management_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_management_fee"]) : mdlPackageMaster.dblSupCurManagementFee;
				mdlPackageMaster.dblSupCurDiscountPerc = (DBNull.Value != objRecord["dbl_sup_cur_discount_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_discount_perc"]) : mdlPackageMaster.dblSupCurDiscountPerc;
				mdlPackageMaster.dblSupCurDiscount = (DBNull.Value != objRecord["dbl_sup_cur_discount"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_discount"]) : mdlPackageMaster.dblSupCurDiscount;
				mdlPackageMaster.dblSupCurCost = (DBNull.Value != objRecord["dbl_sup_cur_cost"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_cost"]) : mdlPackageMaster.dblSupCurCost;
				mdlPackageMaster.dblSupCurPrice = (DBNull.Value != objRecord["dbl_sup_cur_price"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_cur_price"]) : mdlPackageMaster.dblSupCurPrice;

				mdlPackageMaster.jsnBatchDetails = (DBNull.Value != objRecord["jsn_batch_details"]) ? Convert.ToString(objRecord["jsn_batch_details"]) : mdlPackageMaster.jsnBatchDetails;

				mdlPackageMaster.sinRecordStatus = (DBNull.Value != objRecord["sin_record_status"]) ? (short)Convert.ToInt16(objRecord["sin_record_status"]) : mdlPackageMaster.sinRecordStatus;
				mdlPackageMaster.sinOrder = (DBNull.Value != objRecord["sin_order"]) ? (short)Convert.ToInt16(objRecord["sin_order"]) : mdlPackageMaster.sinOrder;


				mdlPackageMaster.intSysActionId = (DBNull.Value != objRecord["int_sys_action_id"]) ? (int)Convert.ToInt32(objRecord["int_sys_action_id"]) : mdlPackageMaster.intSysActionId;
				mdlPackageMaster.binCreatedUserId = (DBNull.Value != objRecord["fk_created_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_created_user_id"]) : mdlPackageMaster.binCreatedUserId;
				mdlPackageMaster.strCreatedUser = this.insDbService.FnGetValue(objRecord["vhr_created_user"], mdlPackageMaster.strCreatedUser);
				mdlPackageMaster.dtmCreated = (DBNull.Value != objRecord["dtm_created"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_created"]) : mdlPackageMaster.dtmCreated;
				mdlPackageMaster.binLastModifiedUserId = (DBNull.Value != objRecord["fk_last_modified_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_last_modified_user_id"]) : mdlPackageMaster.binLastModifiedUserId;
				mdlPackageMaster.strLastModifiedUser = this.insDbService.FnGetValue(objRecord["vhr_last_modified_user"], mdlPackageMaster.strLastModifiedUser);
				mdlPackageMaster.dtmLastModified = (DBNull.Value != objRecord["dtm_last_modified"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_last_modified"]) : mdlPackageMaster.dtmLastModified;
				mdlPackageMaster.binDeletedUserId = (DBNull.Value != objRecord["fk_deleted_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_deleted_user_id"]) : mdlPackageMaster.binDeletedUserId;
				mdlPackageMaster.strDeletedUser = this.insDbService.FnGetValue(objRecord["vhr_deleted_user"], mdlPackageMaster.strDeletedUser);
				mdlPackageMaster.dtmDeleted = (DBNull.Value != objRecord["dtm_deleted"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_deleted"]) : mdlPackageMaster.dtmDeleted;

        
                        lstMdlPackageMaster.Add(mdlPackageMaster);
                    }
                }

                return lstMdlPackageMaster;
            }
        


            public MdlResPackageMaster FnInsertOrUpdatePackageMaster(MdlReqPackageMaster mdlReqPackageMaster)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqPackageMaster.mdlPackageMaster.binPackageMasterId == 0)
                {
                    mdlReqPackageMaster.mdlPackageMaster.intSysActionId = 0;
                    mdlReqPackageMaster.mdlPackageMaster.binCreatedUserId = mdlReqPackageMaster.linLoginUserId;
                    mdlReqPackageMaster.mdlPackageMaster.strCreatedUser = mdlReqPackageMaster.strLoginUserName;
                    mdlReqPackageMaster.mdlPackageMaster.dtmCreated = mdlReqPackageMaster.dtmCurrentDateTime;
                }
                else {
                    mdlReqPackageMaster.mdlPackageMaster.binLastModifiedUserId = mdlReqPackageMaster.linLoginUserId;
                    mdlReqPackageMaster.mdlPackageMaster.strLastModifiedUser = mdlReqPackageMaster.strLoginUserName;
                    mdlReqPackageMaster.mdlPackageMaster.dtmLastModified = mdlReqPackageMaster.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlPackageMaster", NpgsqlDbType.Jsonb) { Value = mdlReqPackageMaster.mdlPackageMaster, DataTypeName = "jsnPackageMaster"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_packageMaster(:mdlPackageMaster, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEMASTER.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEMASTER.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEMASTER.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResPackageMaster mdlResPackageMaster = new MdlResPackageMaster();
                mdlResPackageMaster.mdlPackageMaster = mdlPackageMasterReq.mdlPackageMaster;
                if (mdlReqPackageMaster.mdlPackageMaster.binPackageMasterId == 0)
                {
                    mdlResPackageMaster.mdlPackageMaster.binPackageMasterId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResPackageMaster.mdlPackageMaster.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResPackageMaster.mdlPackageMaster.intSysActionId += 1;
                    mdlResPackageMaster.mdlPackageMaster.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResPackageMaster.sinStatus = 1;
                mdlResPackageMaster.strStatusCode = "SUCCESS";
                mdlResPackageMaster.strMessage = "PACKAGEMASTER has been Saved.";
                
                return mdlResPackageMaster;
            } 
        


            public MdlResBaseIntId FnDeletePackageMaster(MdlReqBaseIntId mdlReqPackageMasterBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binPackageMasterId", NpgsqlDbType.Bigint) { Value = mdlReqPackageMasterBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binPackageMasterId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqPackageMasterBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqPackageMasterBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_packageMaster(:binPackageMasterId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEMASTER.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEMASTER.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEMASTER.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResPackageMasterIntId = new MdlResBaseIntId();

                mdlResPackageMasterIntId.mdlBaseIntId = mdlReqPackageMasterBaseIntId.mdlBaseIntId;
                mdlResPackageMasterIntId.sinStatus = 1;
                mdlResPackageMasterIntId.strStatusCode = "SUCCESS";
                mdlResPackageMasterIntId.strMessage = "PACKAGEMASTER has been deleted.";

                return mdlResPackageMasterIntId;
            }
        

