???File Path
==========
***...\ClientApp\srcpp\src\travel\package-details\package-details.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlPackageDetails, MdlReqPackageDetails, MdlResPackageDetails, MdlResPackageDetailsInit, MdlResPackageDetailsList } from '../../../models/travel/package.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class PackageDetailsComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlPackageDetails: MdlPackageDetails = new MdlPackageDetails();
                public intActivePackageDetailsIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlPackageMasterBaseIntId: MdlBaseIntId[] = [];
			lstMdlCommissionAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlSupFeeAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlSupplierAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlServiceFeeAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlDiscountAcBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** PackageDetails List
                @ViewChild('#idDgPackageDetailsList') idDgPackageDetailsList!: DxDataGridComponent;
                public lstAllPackageDetails: MdlPackageDetails[] = [];
                public blnDgPackageDetailsShowFilterRow: boolean = false;
                public blnDgPackageDetailsHeaderFilter: boolean = false;
                public intActivePackageDetailsListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'packageDetails';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "PACKAGEDETAILS_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("PackageDetails");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetPackageDetailsInitializeData')
                    .then((mdlResPackageDetailsInit: MdlResPackageDetailsInit) => {
                        if (mdlResPackageDetailsInit.sinStatus == 1) {
                            this.lstMdlPackageDetails = mdlResPackageDetailsInit.lstMdlPackageDetails;

                            // ??? Remove not use items !!!
					this.lstMdlPackageMasterBaseIntId = mdlResPackageDetailsInit.lstMdlPackageMasterBaseIntId;
					this.lstMdlCommissionAcBaseIntId = mdlResPackageDetailsInit.lstMdlCommissionAcBaseIntId;
					this.lstMdlSupFeeAcBaseIntId = mdlResPackageDetailsInit.lstMdlSupFeeAcBaseIntId;
					this.lstMdlSupplierAcBaseIntId = mdlResPackageDetailsInit.lstMdlSupplierAcBaseIntId;
					this.lstMdlServiceFeeAcBaseIntId = mdlResPackageDetailsInit.lstMdlServiceFeeAcBaseIntId;
					this.lstMdlDiscountAcBaseIntId = mdlResPackageDetailsInit.lstMdlDiscountAcBaseIntId;

                        } else {
                            console.log(mdlResPackageDetailsInit.strMessage + " => " + mdlResPackageDetailsInit.strErrorCode + ' -> ' + mdlResPackageDetailsInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->PACKAGEDETAILS.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnPackageDetailsListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnPackageDetailsListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlPackageDetails);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqPackageDetails: MdlReqPackageDetails = new MdlReqPackageDetails();
            mdlReqPackageDetails.mdlPackageDetails = JSON.parse(JSON.stringify(this.mdlPackageDetails));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SavePackageDetails', mdlReqPackageDetails)
                .then((mdlResPackageDetails: MdlResPackageDetails) => {
                if (mdlResPackageDetails.sinStatus == 1) {
                    this.mdlPackageDetails = mdlResPackageDetails.mdlPackageDetails;
                    if (this.intActivePackageDetailsIndex == -1) {
                    // New Item
                    this.intActivePackageDetailsIndex = this.lstMdlPackageDetails.length;
                    this.lstMdlPackageDetails.push(JSON.parse(JSON.stringify(this.mdlPackageDetails)));
                    }
                    else {
                    // Update
                    this.lstMdlPackageDetails[this.intActivePackageDetailsIndex] = JSON.parse(JSON.stringify(this.mdlPackageDetails));
                    //this.lstMdlPackageDetails.splice(this.intActivePackageDetailsIndex, 1, this.mdlPackageDetails);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResPackageDetails.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResPackageDetails.strMessage, mdlResPackageDetails.strSysError);
                    console.log(mdlResPackageDetails);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->PACKAGEDETAILS.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlPackageDetails.binPackageDetailsId == null || this.mdlPackageDetails.binPackageDetailsId < 1) {
                throw new Error('Select PackageDetails for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqPackageDetailsBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqPackageDetailsBaseIntId.mdlBaseIntId.binPkId = this.mdlPackageDetails.binPackageDetailsId;
            mdlReqPackageDetailsBaseIntId.mdlBaseIntId.binCustomValue = this.mdlPackageDetails.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeletePackageDetails', mdlReqPackageDetailsBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlPackageDetails.splice(this.intActivePackageDetailsIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->PACKAGEDETAILS.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlPackageDetails = new MdlPackageDetails();
                    this.intActivePackageDetailsIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlPackageDetails: MdlPackageDetails, intRowIndex: number) {
                this.mdlPackageDetails = JSON.parse(JSON.stringify(mdlPackageDetails));
                this.intActivePackageDetailsIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlPackageDetails: MdlPackageDetails) {
                // ??? CHECK
                
                if (mdlPackageDetails.binPackageMasterId == 0) {
                    throw new Error('Enter/Select Package Master.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

