???File Path
==========
***...\Src\Travel\PackageDetails.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Travel;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllPackageDetailsBaseData()
            {
                List<MdlBaseIntId> lstMdlPackageDetailsBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_package_details()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_package_details_id"]) ? (long)Convert.ToUInt64(objRecord["pk_package_details_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strName;
        
                        lstMdlPackageDetailsBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlPackageDetailsBaseIntId;
            }
        


            public List<MdlPackageDetails> FnGetAllPackageDetailsWithActionUser()
            {
                List<MdlPackageDetails> lstMdlPackageDetails = new List<MdlPackageDetails>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_package_details_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlPackageDetails mdlPackageDetails = new MdlPackageDetails();

                        
				mdlPackageDetails.binPackageDetailsId = (DBNull.Value != objRecord["pk_package_details_id"]) ? (long)Convert.ToInt64(objRecord["pk_package_details_id"]) : mdlPackageDetails.binPackageDetailsId;
				mdlPackageDetails.binPackageMasterId = (DBNull.Value != objRecord["fk_package_master_id"]) ? (long)Convert.ToInt64(objRecord["fk_package_master_id"]) : mdlPackageDetails.binPackageMasterId;
				mdlPackageDetails.sinType = (DBNull.Value != objRecord["sin_type"]) ? (short)Convert.ToInt16(objRecord["sin_type"]) : mdlPackageDetails.sinType;

				mdlPackageDetails.binCommissionAcId = (DBNull.Value != objRecord["fk_commission_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_commission_ac_id"]) : mdlPackageDetails.binCommissionAcId;
				mdlPackageDetails.binSupFeeAcId = (DBNull.Value != objRecord["fk_sup_fee_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_sup_fee_ac_id"]) : mdlPackageDetails.binSupFeeAcId;
				mdlPackageDetails.binSupplierAcId = (DBNull.Value != objRecord["fk_supplier_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_supplier_ac_id"]) : mdlPackageDetails.binSupplierAcId;
				mdlPackageDetails.binServiceFeeAcId = (DBNull.Value != objRecord["fk_service_fee_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_service_fee_ac_id"]) : mdlPackageDetails.binServiceFeeAcId;
				mdlPackageDetails.binDiscountAcId = (DBNull.Value != objRecord["fk_discount_ac_id"]) ? (long)Convert.ToInt64(objRecord["fk_discount_ac_id"]) : mdlPackageDetails.binDiscountAcId;

				mdlPackageDetails.strParticulars = (DBNull.Value != objRecord["txt_particulars"]) ? Convert.ToString(objRecord["txt_particulars"]) : mdlPackageDetails.strParticulars;

				mdlPackageDetails.dblFare = (DBNull.Value != objRecord["dbl_fare"]) ? (double)Convert.ToDouble(objRecord["dbl_fare"]) : mdlPackageDetails.dblFare;
				mdlPackageDetails.dblTax = (DBNull.Value != objRecord["dbl_tax"]) ? (double)Convert.ToDouble(objRecord["dbl_tax"]) : mdlPackageDetails.dblTax;
				mdlPackageDetails.dblCommission = (DBNull.Value != objRecord["dbl_commission"]) ? (double)Convert.ToDouble(objRecord["dbl_commission"]) : mdlPackageDetails.dblCommission;
				mdlPackageDetails.dblSupFee = (DBNull.Value != objRecord["dbl_sup_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_sup_fee"]) : mdlPackageDetails.dblSupFee;
				mdlPackageDetails.dblCost = (DBNull.Value != objRecord["dbl_cost"]) ? (double)Convert.ToDouble(objRecord["dbl_cost"]) : mdlPackageDetails.dblCost;
				mdlPackageDetails.dblServiceFee = (DBNull.Value != objRecord["dbl_service_fee"]) ? (double)Convert.ToDouble(objRecord["dbl_service_fee"]) : mdlPackageDetails.dblServiceFee;
				mdlPackageDetails.dblDiscount = (DBNull.Value != objRecord["dbl_discount"]) ? (double)Convert.ToDouble(objRecord["dbl_discount"]) : mdlPackageDetails.dblDiscount;
				mdlPackageDetails.dblPrice = (DBNull.Value != objRecord["dbl_price"]) ? (double)Convert.ToDouble(objRecord["dbl_price"]) : mdlPackageDetails.dblPrice;


        
                        lstMdlPackageDetails.Add(mdlPackageDetails);
                    }
                }

                return lstMdlPackageDetails;
            }
        


            public MdlResPackageDetails FnInsertOrUpdatePackageDetails(MdlReqPackageDetails mdlReqPackageDetails)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqPackageDetails.mdlPackageDetails.binPackageDetailsId == 0)
                {
                    mdlReqPackageDetails.mdlPackageDetails.intSysActionId = 0;
                    mdlReqPackageDetails.mdlPackageDetails.binCreatedUserId = mdlReqPackageDetails.linLoginUserId;
                    mdlReqPackageDetails.mdlPackageDetails.strCreatedUser = mdlReqPackageDetails.strLoginUserName;
                    mdlReqPackageDetails.mdlPackageDetails.dtmCreated = mdlReqPackageDetails.dtmCurrentDateTime;
                }
                else {
                    mdlReqPackageDetails.mdlPackageDetails.binLastModifiedUserId = mdlReqPackageDetails.linLoginUserId;
                    mdlReqPackageDetails.mdlPackageDetails.strLastModifiedUser = mdlReqPackageDetails.strLoginUserName;
                    mdlReqPackageDetails.mdlPackageDetails.dtmLastModified = mdlReqPackageDetails.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlPackageDetails", NpgsqlDbType.Jsonb) { Value = mdlReqPackageDetails.mdlPackageDetails, DataTypeName = "jsnPackageDetails"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_packageDetails(:mdlPackageDetails, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEDETAILS.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEDETAILS.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEDETAILS.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResPackageDetails mdlResPackageDetails = new MdlResPackageDetails();
                mdlResPackageDetails.mdlPackageDetails = mdlPackageDetailsReq.mdlPackageDetails;
                if (mdlReqPackageDetails.mdlPackageDetails.binPackageDetailsId == 0)
                {
                    mdlResPackageDetails.mdlPackageDetails.binPackageDetailsId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResPackageDetails.mdlPackageDetails.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResPackageDetails.mdlPackageDetails.intSysActionId += 1;
                    mdlResPackageDetails.mdlPackageDetails.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResPackageDetails.sinStatus = 1;
                mdlResPackageDetails.strStatusCode = "SUCCESS";
                mdlResPackageDetails.strMessage = "PACKAGEDETAILS has been Saved.";
                
                return mdlResPackageDetails;
            } 
        


            public MdlResBaseIntId FnDeletePackageDetails(MdlReqBaseIntId mdlReqPackageDetailsBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binPackageDetailsId", NpgsqlDbType.Bigint) { Value = mdlReqPackageDetailsBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binPackageDetailsId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqPackageDetailsBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqPackageDetailsBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_packageDetails(:binPackageDetailsId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEDETAILS.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEDETAILS.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "PACKAGEDETAILS.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResPackageDetailsIntId = new MdlResBaseIntId();

                mdlResPackageDetailsIntId.mdlBaseIntId = mdlReqPackageDetailsBaseIntId.mdlBaseIntId;
                mdlResPackageDetailsIntId.sinStatus = 1;
                mdlResPackageDetailsIntId.strStatusCode = "SUCCESS";
                mdlResPackageDetailsIntId.strMessage = "PACKAGEDETAILS has been deleted.";

                return mdlResPackageDetailsIntId;
            }
        

