???File Path
==========
***...\ClientApp\srcpp\src\accounts\package-master\package-master.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlPackageMaster, MdlReqPackageMaster, MdlResPackageMaster, MdlResPackageMasterInit, MdlResPackageMasterList } from '../../../models/accounts/package.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class PackageMasterComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlPackageMaster: MdlPackageMaster = new MdlPackageMaster();
                public intActivePackageMasterIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlPackageCategoryBaseIntId: MdlBaseIntId[] = [];
			lstMdlIncomeAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlControlAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlSupplierAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlSupplierSideControlAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlCommissionAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlServiceFeeAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlManagementFeeAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlPaybackAcBaseIntId: MdlBaseIntId[] = [];
			lstMdlDiscountAcBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** PackageMaster List
                @ViewChild('#idDgPackageMasterList') idDgPackageMasterList!: DxDataGridComponent;
                public lstAllPackageMaster: MdlPackageMaster[] = [];
                public blnDgPackageMasterShowFilterRow: boolean = false;
                public blnDgPackageMasterHeaderFilter: boolean = false;
                public intActivePackageMasterListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'packageMaster';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "PACKAGEMASTER_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("PackageMaster");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetPackageMasterInitializeData')
                    .then((mdlResPackageMasterInit: MdlResPackageMasterInit) => {
                        if (mdlResPackageMasterInit.sinStatus == 1) {
                            this.lstMdlPackageMaster = mdlResPackageMasterInit.lstMdlPackageMaster;

                            // ??? Remove not use items !!!
					this.lstMdlPackageCategoryBaseIntId = mdlResPackageMasterInit.lstMdlPackageCategoryBaseIntId;
					this.lstMdlIncomeAcBaseIntId = mdlResPackageMasterInit.lstMdlIncomeAcBaseIntId;
					this.lstMdlControlAcBaseIntId = mdlResPackageMasterInit.lstMdlControlAcBaseIntId;
					this.lstMdlSupplierAcBaseIntId = mdlResPackageMasterInit.lstMdlSupplierAcBaseIntId;
					this.lstMdlSupplierSideControlAcBaseIntId = mdlResPackageMasterInit.lstMdlSupplierSideControlAcBaseIntId;
					this.lstMdlCommissionAcBaseIntId = mdlResPackageMasterInit.lstMdlCommissionAcBaseIntId;
					this.lstMdlServiceFeeAcBaseIntId = mdlResPackageMasterInit.lstMdlServiceFeeAcBaseIntId;
					this.lstMdlManagementFeeAcBaseIntId = mdlResPackageMasterInit.lstMdlManagementFeeAcBaseIntId;
					this.lstMdlPaybackAcBaseIntId = mdlResPackageMasterInit.lstMdlPaybackAcBaseIntId;
					this.lstMdlDiscountAcBaseIntId = mdlResPackageMasterInit.lstMdlDiscountAcBaseIntId;

                        } else {
                            console.log(mdlResPackageMasterInit.strMessage + " => " + mdlResPackageMasterInit.strErrorCode + ' -> ' + mdlResPackageMasterInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->PACKAGEMASTER.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnPackageMasterListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnPackageMasterListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlPackageMaster);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqPackageMaster: MdlReqPackageMaster = new MdlReqPackageMaster();
            mdlReqPackageMaster.mdlPackageMaster = JSON.parse(JSON.stringify(this.mdlPackageMaster));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SavePackageMaster', mdlReqPackageMaster)
                .then((mdlResPackageMaster: MdlResPackageMaster) => {
                if (mdlResPackageMaster.sinStatus == 1) {
                    this.mdlPackageMaster = mdlResPackageMaster.mdlPackageMaster;
                    if (this.intActivePackageMasterIndex == -1) {
                    // New Item
                    this.intActivePackageMasterIndex = this.lstMdlPackageMaster.length;
                    this.lstMdlPackageMaster.push(JSON.parse(JSON.stringify(this.mdlPackageMaster)));
                    }
                    else {
                    // Update
                    this.lstMdlPackageMaster[this.intActivePackageMasterIndex] = JSON.parse(JSON.stringify(this.mdlPackageMaster));
                    //this.lstMdlPackageMaster.splice(this.intActivePackageMasterIndex, 1, this.mdlPackageMaster);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResPackageMaster.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResPackageMaster.strMessage, mdlResPackageMaster.strSysError);
                    console.log(mdlResPackageMaster);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->PACKAGEMASTER.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlPackageMaster.binPackageMasterId == null || this.mdlPackageMaster.binPackageMasterId < 1) {
                throw new Error('Select PackageMaster for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqPackageMasterBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqPackageMasterBaseIntId.mdlBaseIntId.binPkId = this.mdlPackageMaster.binPackageMasterId;
            mdlReqPackageMasterBaseIntId.mdlBaseIntId.binCustomValue = this.mdlPackageMaster.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeletePackageMaster', mdlReqPackageMasterBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlPackageMaster.splice(this.intActivePackageMasterIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->PACKAGEMASTER.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlPackageMaster = new MdlPackageMaster();
                    this.intActivePackageMasterIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlPackageMaster: MdlPackageMaster, intRowIndex: number) {
                this.mdlPackageMaster = JSON.parse(JSON.stringify(mdlPackageMaster));
                this.intActivePackageMasterIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlPackageMaster: MdlPackageMaster) {
                // ??? CHECK
                
                if (mdlPackageMaster.binPackageCategoryId == 0) {
                    throw new Error('Enter/Select Package Category.');
                }
            
                if (mdlPackageMaster.strPackageCode == "") {
                    throw new Error('Enter/Select Package Code.');
                }
            
                if (mdlPackageMaster.strPackageName == "") {
                    throw new Error('Enter/Select Package Name.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

